QGIS Application - Bug report #7073

Intersection Tool Produces two Intersection points on the same position when performed on Same
Layer

2013-01-29 11:56 AM - Sibi Prabakaran

Status: Closed

Priority: Normal

Assignee: Sibi Prabakaran

Category: Processing/QGIS

Affected QGIS version:master Regression?:

Operating System: Ubuntu Linux Easy fix?:

Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16157
Description

Platform Used: Ubuntu Linux 32-bit
The Intersection tool when performed on the same layer produces two intersection points overlapping each other.
Their attribute table data for the intersected points is something like this:

1,2
2,1

Related issues:
Related to QGIS Application - Bug report # 7021: Line Intersection tool produ... Closed 2013-01-21

Associated revisions

Revision 1a95297c¢ - 2013-07-11 12:18 AM - Daniel Vaz

Fix #7073

Revision 56210eb0 - 2013-07-11 03:11 AM - Nathan Woodrow
Merge pull request #711 from ddanielvaz/bugfixes

Bugfixes for fTools.

Fix #8218

Fix #8069
Fix #7073

History

#1 - 2013-01-29 12:00 PM - Sibi Prabakaran
- % Done changed from 0 to 100

Pull Request submitted in https://github.com/ggis/Quantum-GIS/pull/414

#2 - 2013-07-03 12:14 AM - Matthias Kuhn
- Status changed from Open to Feedback
https://github.com/qgis/Quantum-GIS/pull/414

Is this bugreport still valid after #7021 has been fixed?

#3 - 2013-07-05 01:56 AM - Giovanni Manghi

Matthias Kuhn wrote:

Is this bugreport still valid after #7021 has been fixed?

yes, because the result layer is empty.
Moreover if the tool is run using two different shapes | get
Traceback (most recent call last):
File "C:\OSGeo4W\\apps\\qgis-dev\\python\\plugins\\fTools\\tools\\dolIntersectLines.py", line 96, in accept
self.compute(linet, line2, field1, field2, outPath, self.progressBar)
File "C:\OSGeo4W\\apps\\qgis-dev\\python\\plugins\\fTools\\tools\\dolIntersectLines.py", line 169, in compute
outFeat.setAttribute(0, v1)
KeyError: '0'
| get the same error when running the tool using postgis layers.

#4 - 2013-07-05 10:46 AM - Daniel Vaz
- File dointersectLines.diff added

When lines are in the same layer, | think that there is a problem using the same provider to iterate over both lines. There is a strange behaviour, | don't know

why, but it looks like that code:

provider2.select(allAttrs)

overriden the provider1, so in the loop:

while provider1.nextFeature(inFeat):

the attribute map of each feature (inFeat.attributeMap()) is an empty dict.

The patch attached includes the patch proposed by Sibi and adds a HACK that solves the problem, but it's not the correct way, | think.

#5 - 2013-07-05 10:48 AM - Daniel Vaz
The hack that solves the problem, is added the following two lines before the while loop.
allAttrs = provider1.attributelndexes()

provider1.select(allAttrs)
while provider1.nextFeature(inFeat):
#6 - 2013-07-06 06:25 AM - Daniel Vaz

See pull request 702. https:/github.com/qgis/Quantum-GIS/pull/702

#7 - 2013-07-10 06:11 PM - Nathan Woodrow
- Status changed from Feedback to Closed

Fixed in changeset commit:"56210eb0b5c7914d246b1c82ad48e676b00b6557".

#8 - 2017-05-01 01:22 AM - Giovanni Manghi

The "ftools" category is being removed from the tracker, changing the category of this ticket to "Processing/QGIS" to not leave the category orphaned.

Files

dolntersectLines.diff 1.91 KB 2013-07-05 Daniel Vaz
https://github.com/qgis/Quantum-GIS/pull/702

